# -*- coding: utf-8 -*-

import os
import ssl
import gzip
import StringIO
import datetime
import urllib
import urllib2
import simplejson as json
from traceback import format_exc


def send_req(url, postdata=None, json_req=False, headers={}, proxy_host=''):
    """
    发送http请求，
    postdata不为None时，发送post请求
    postdata为None时，发送get请求
    """
    print datetime.datetime.now()
    if proxy_host:
        print proxy_host
    if os.environ.get('http_proxy', '') != proxy_host:
        os.environ['http_proxy'] = proxy_host
        proxy = urllib2.ProxyHandler({'http': proxy_host})
        opener = urllib2.build_opener(proxy)
        urllib2.install_opener(opener)
        # print os.environ
    else:
        if 'http_proxy' in os.environ:
            del os.environ['http_proxy']
    print url, postdata

    if postdata:
        if json_req:
            js_data = json.dumps(postdata, ensure_ascii=False).encode("utf8")
            req = urllib2.Request(url, js_data)
            req.add_header('Content-Type', 'application/json')
        else:
            req = urllib2.Request(url, urllib.urlencode(postdata))
    else:
        req = urllib2.Request(url)
    if headers:
        print headers
        req.headers = headers
    req.add_header('encoding', 'utf-8')

    try:
        if url.startswith("https"):
            context = ssl._create_unverified_context()
            response = urllib2.urlopen(req, context=context, timeout=20)
        else:
            response = urllib2.urlopen(req, timeout=10)
        resp_encoding = response.headers.get('Content-Encoding', '')
        if resp_encoding == 'gzip':
            gz_content = response.read()
            compressedstream = StringIO.StringIO(gz_content)
            gzipper = gzip.GzipFile(fileobj=compressedstream)
            resp = gzipper.read()
        else:
            resp = response.read()
            resp_type = response.headers.get('Content-Type', '')
        if "json" in resp_type:
            resp = json.loads(resp)

    except urllib2.URLError, e:
        error_info = format_exc()
        return error_info
    except Exception, e:
        error_info = format_exc()
        print e
        print error_info
        return error_info
    print datetime.datetime.now()
    return resp

